#version 400
layout (location = 0) in vec3 vert_pos;
layout (location = 1) in vec3 vert_norm;
layout (location = 2) in vec2 vert_uv;

uniform mat4 MVP;
uniform vec3 lightdir; //NOT NORMALIZED
uniform vec3 cameradir; //NOT NORMALIZED

out vec2 uv;
out vec3 frag_pos_v;
out vec3 frag_norm_v;
out vec3 light_dir_v; //DONT NORMALIZE
out vec3 cam_dir_v; //DONT NORMALIZE

void main(){
    vec4 pos = vec4(vert_pos, 1.0);
    gl_Position = MVP*pos;
    
    frag_pos_v = pos.xyz;
    uv = vert_uv;

    frag_norm_v = normalize(vert_norm);
    light_dir_v = lightdir;
    cam_dir_v = cameradir;
}